diff --git a/src/backend/replication/logical/worker.c b/src/backend/replication/logical/worker.c
index 3d58910c14..7311ca75ab 100644
--- a/src/backend/replication/logical/worker.c
+++ b/src/backend/replication/logical/worker.c
@@ -153,6 +153,7 @@
 #include "catalog/pg_subscription.h"
 #include "catalog/pg_subscription_rel.h"
 #include "catalog/pg_tablespace.h"
+#include "common/file_utils.h"
 #include "commands/tablecmds.h"
 #include "commands/tablespace.h"
 #include "commands/trigger.h"
@@ -370,67 +371,742 @@ typedef struct ApplySubXactData
 
 static ApplySubXactData subxact_data = {0, 0, InvalidTransactionId, NULL};
 
+/* XXX definitions for time-delayed logical replicaiton */
+
+/* DELAYEDDIR stores files that contains changes of delayed transactions. */
+#define DELAYEDDIR	"pg_logical/delayed_txns"
+#define DELAYEDSUFFIX	".delayed_changes"
+
+/* List entry to map xid and commit time */
+typedef struct DelayedTxnListEntry
+{
+	TransactionId xid;
+	LogicalRepCommitData commit_data;
+} DelayedTxnListEntry;
+
+/*
+ * An entry is appended when the we receives commit message and time-delayed
+ * logical replication is requested. The entry will be deleted after contents
+ * are applied.
+ */
+static List *DelayedTxnList = NIL;
+
+/* fields valid only when time-delayed logical replication is requested */
+static bool in_delayed_transaction = false;
+
+static TransactionId delayed_xid = InvalidTransactionId;
+
+/*
+ * Store flushed lsn for time-delayed logical replication. This is used when
+ * we send a feedback message to the publisher.
+ */
+static XLogRecPtr last_flushed = InvalidXLogRecPtr;
+
+/*
+ * FIXME: global file descriptor may be not sufficient. There is a possibility
+ * that non-streaming transactions are come concurrently. At that time
+ * create_delay_file() for the second transaction will be failed...
+ */
+static int delayed_fd = -1;
+
 static inline void subxact_filename(char *path, Oid subid, TransactionId xid);
 static inline void changes_filename(char *path, Oid subid, TransactionId xid);
 
 /*
- * Information about subtransactions of a given toplevel transaction.
+ * Information about subtransactions of a given toplevel transaction.
+ */
+static void subxact_info_write(Oid subid, TransactionId xid);
+static void subxact_info_read(Oid subid, TransactionId xid);
+static void subxact_info_add(TransactionId xid);
+static inline void cleanup_subxact_info(void);
+
+/*
+ * Serialize and deserialize changes for a toplevel transaction.
+ */
+static void stream_open_file(Oid subid, TransactionId xid,
+							 bool first_segment);
+static void stream_write_change(char action, StringInfo s);
+static void stream_open_and_write_change(TransactionId xid, char action, StringInfo s);
+static void stream_close_file(void);
+
+static void send_feedback(XLogRecPtr recvpos, bool force, bool requestReply);
+
+static void DisableSubscriptionAndExit(void);
+
+static void apply_handle_commit_internal(LogicalRepCommitData *commit_data);
+static void apply_handle_insert_internal(ApplyExecutionData *edata,
+										 ResultRelInfo *relinfo,
+										 TupleTableSlot *remoteslot);
+static void apply_handle_update_internal(ApplyExecutionData *edata,
+										 ResultRelInfo *relinfo,
+										 TupleTableSlot *remoteslot,
+										 LogicalRepTupleData *newtup,
+										 Oid localindexoid);
+static void apply_handle_delete_internal(ApplyExecutionData *edata,
+										 ResultRelInfo *relinfo,
+										 TupleTableSlot *remoteslot,
+										 Oid localindexoid);
+static bool FindReplTupleInLocalRel(EState *estate, Relation localrel,
+									LogicalRepRelation *remoterel,
+									Oid localidxoid,
+									TupleTableSlot *remoteslot,
+									TupleTableSlot **localslot);
+static void apply_handle_tuple_routing(ApplyExecutionData *edata,
+									   TupleTableSlot *remoteslot,
+									   LogicalRepTupleData *newtup,
+									   CmdType operation);
+
+/* Compute GID for two_phase transactions */
+static void TwoPhaseTransactionGid(Oid subid, TransactionId xid, char *gid, int szgid);
+
+/* Functions for skipping changes */
+static void maybe_start_skipping_changes(XLogRecPtr finish_lsn);
+static void stop_skipping_changes(void);
+static void clear_subscription_skip_lsn(XLogRecPtr finish_lsn);
+
+/* Functions for apply error callback */
+static inline void set_apply_error_context_xact(TransactionId xid, XLogRecPtr lsn);
+static inline void reset_apply_error_context_info(void);
+
+static TransApplyAction get_transaction_apply_action(TransactionId xid,
+													 ParallelApplyWorkerInfo **winfo);
+
+static void begin_replication_step(void);
+static void end_replication_step(void);
+
+/* Functions for time-delayed logical replicaiton */
+static void cache_commit_data(LogicalRepCommitData *commit_data, TransactionId xid);
+static void flush_delayed_changes(LogicalRepCommitData *commit_data);
+static void delay_file_name(char *path, Oid subid, TransactionId xid);
+static bool is_given_transaction_delayed(Oid subid, TransactionId xid);
+static void create_delay_file(TransactionId xid);
+static bool handle_delayed_transaction(char action, StringInfo s);
+static void handle_delayed_prepared(char action, XLogRecPtr prepare_lsn,
+							XLogRecPtr end_lsn, TimestampTz prepare_time,
+							TransactionId xid);
+
+/*
+ * Cache commit_data into the list
+ */
+static void
+cache_commit_data(LogicalRepCommitData *commit_data, TransactionId xid)
+{
+	MemoryContext old;
+	DelayedTxnListEntry *entry;
+
+	old = MemoryContextSwitchTo(ApplyContext);
+
+	entry = palloc0(sizeof(DelayedTxnListEntry));
+
+	/* Contruct an entry and append it */
+	entry->xid = xid;
+	memcpy(&entry->commit_data, commit_data, sizeof(LogicalRepCommitData));
+	DelayedTxnList = lappend(DelayedTxnList, entry);
+
+	MemoryContextSwitchTo(old);
+}
+
+/*
+ * Flush given changes and close the file. This will be called at the end of
+ * the transaction.
+ */
+static void
+flush_delayed_changes(LogicalRepCommitData *commit_data)
+{
+	Assert(delayed_fd > 0);
+	Assert(TransactionIdIsValid(delayed_xid));
+
+	/* Cache given commit_data into the list */
+	cache_commit_data(commit_data, delayed_xid);
+
+	/* Flush previously written changes */
+	if (pg_fdatasync(delayed_fd) != 0)
+	{
+		int save_errno = errno;
+		close(delayed_fd);
+		errno = save_errno;
+		ereport(ERROR,
+				errcode_for_file_access(),
+				errmsg("could not fsync file"));
+	}
+
+	/* Store flushed lsn */
+	last_flushed = commit_data->end_lsn;
+
+	/* Cleanup */
+	close(delayed_fd);
+	delayed_fd = -1;
+	delayed_xid = InvalidTransactionId;
+	in_delayed_transaction = false;
+}
+
+/*
+ * Get formal filename from subid and xid
+ */
+static void
+delay_file_name(char *path, Oid subid, TransactionId xid)
+{
+	snprintf(path, MAXPGPATH, DELAYEDDIR "/%u-%u" DELAYEDSUFFIX, subid, xid);
+}
+
+/*
+ * Extract subid and xid and given pathname
+ */
+static void
+extract_info_from_delay_file(char *path, Oid *subid, TransactionId *xid)
+{
+	sscanf(path, DELAYEDDIR "/%u-%u", subid, xid);
+}
+
+/*
+ * Check whether the given transaction is delayed. This is done by checking the
+ * delay file.
+ */
+static bool
+is_given_transaction_delayed(Oid subid, TransactionId xid)
+{
+	struct stat st;
+	char		path[MAXPGPATH];
+
+	delay_file_name(path, subid, xid);
+
+	return stat(path, &st) == 0;
+}
+
+/*
+ * Apply the delayed transaction. In the function a delayed file is opened and
+ * read. Apply worker applies written changes.
+ */
+static void
+apply_delayed_transaction(TransactionId xid, XLogRecPtr lsn)
+{
+	StringInfoData s2;
+	int			nchanges;
+	char		path[MAXPGPATH];
+	char	   *buffer = NULL;
+	MemoryContext oldcxt;
+	ResourceOwner oldowner;
+
+	/* Make sure we have an open transaction */
+	begin_replication_step();
+
+	/*
+	 * Allocate file handle and memory required to process all the messages in
+	 * TopTransactionContext to avoid them getting reset after each message is
+	 * processed.
+	 */
+	oldcxt = MemoryContextSwitchTo(TopTransactionContext);
+
+	/* Open the spool file for the committed transaction */
+	delay_file_name(path, MyLogicalRepWorker->subid, xid);
+	elog(DEBUG1, "replaying changes from file \"%s\"", path);
+
+	/*
+	 * Make sure the file is owned by the toplevel transaction so that the
+	 * file will not be accidentally closed when aborting a subtransaction.
+	 */
+	oldowner = CurrentResourceOwner;
+	CurrentResourceOwner = TopTransactionResourceOwner;
+
+	/* Open the specified file */
+	delayed_fd = BasicOpenFile(path, O_RDONLY | PG_BINARY);
+
+	Assert(delayed_fd > 0);
+
+	CurrentResourceOwner = oldowner;
+
+	buffer = palloc(BLCKSZ);
+	initStringInfo(&s2);
+
+	MemoryContextSwitchTo(oldcxt);
+
+	remote_final_lsn = lsn;
+
+	/*
+	 * Make sure the handle apply_dispatch methods are aware we're in a remote
+	 * transaction.
+	 */
+	in_remote_transaction = true;
+	pgstat_report_activity(STATE_RUNNING, NULL);
+
+	end_replication_step();
+
+	/*
+	 * Read the entries one by one and pass them through the same logic as in
+	 * apply_dispatch.
+	 */
+	nchanges = 0;
+	while (true)
+	{
+		size_t		nbytes;
+		int			len;
+
+		CHECK_FOR_INTERRUPTS();
+
+		/* read length of the on-disk record */
+		nbytes = read(delayed_fd, &len, sizeof(len));
+
+		/* have we reached end of the file? */
+		if (nbytes == 0)
+			break;
+
+		/* do we have a correct length? */
+		if (len <= 0)
+			elog(ERROR, "incorrect length %d in delaed transaction's changes file \"%s\"",
+				 len, path);
+
+		/* make sure we have sufficiently large buffer */
+		buffer = repalloc(buffer, len);
+
+		/* and finally read the data into the buffer */
+		read(delayed_fd, buffer, len);
+
+		/* copy the buffer to the stringinfo and call apply_dispatch */
+		resetStringInfo(&s2);
+		appendBinaryStringInfo(&s2, buffer, len);
+
+		/* Ensure we are reading the data into our memory context. */
+		oldcxt = MemoryContextSwitchTo(ApplyMessageContext);
+
+		apply_dispatch(&s2);
+
+		MemoryContextReset(ApplyMessageContext);
+
+		MemoryContextSwitchTo(oldcxt);
+
+		nchanges++;
+
+		if (nchanges % 1000 == 0)
+			elog(DEBUG1, "replayed %d changes from file \"%s\"",
+				 nchanges, path);
+	}
+
+	if (delayed_fd > 0)
+	{
+		close(delayed_fd);
+		delayed_fd = -1;
+		durable_unlink(path, LOG);
+	}
+
+	elog(DEBUG1, "replayed %d (all) changes from file \"%s\"",
+		 nchanges, path);
+
+	return;
+}
+
+/*
+ * Create a file that will be written changes.
+ */
+static void
+create_delay_file(TransactionId xid)
+{
+	char		path[MAXPGPATH];
+	int			fd;
+
+	Assert(TransactionIdIsValid(xid));
+	Assert(delayed_fd < 0);
+
+	delay_file_name(path, MyLogicalRepWorker->subid, xid);
+
+	elog(DEBUG1, "creating a file \"%s\" for time-delayed logical replication",
+		 path);
+
+	fd = BasicOpenFile(path, O_WRONLY | O_CREAT | O_EXCL | O_APPEND | PG_BINARY);
+
+	if (fd < 0)
+		ereport(ERROR,
+				errcode_for_file_access(),
+				errmsg("could not create file \"%s\": %m",
+					   path));
+
+	delayed_fd = fd;
+}
+
+/*
+ * Create a directory that holds delayed files
+ */
+static void
+initialize_delay_directory(void)
+{
+	char		path[MAXPGPATH];
+
+	snprintf(path, MAXPGPATH, DELAYEDDIR);
+	if (MakePGDirectory(path) < 0 && errno != EEXIST)
+		ereport(ERROR,
+			errcode_for_file_access(),
+			errmsg("could not create directory \"%s\": %m",
+				   path));
+
+	START_CRIT_SECTION();
+	fsync_fname(path, true);
+	END_CRIT_SECTION();
+}
+
+/*
+ * Read the delayed file and cache information of transaction e.g. committime
+ */
+static bool
+ReadCommitRecord(int fd, TransactionId xid)
+{
+	int len = 0;
+	char action = 0;
+	char *buffer;
+	StringInfoData commit_message;
+	LogicalRepCommitData commit_data = {0};
+
+	/*
+	 * If the transaction is not 2PC, we can assume that decoded commit record
+	 * is at the end of the file. Therefore, read from the end.
+	 */
+
+	/* FIXME: size of the messages is estimated from the document */
+#define COMMIT_MESSAGE_SIZE (sizeof(int) + sizeof(char) + sizeof(int8) + sizeof(LogicalRepCommitData))
+
+	/* seek file to the end */
+	lseek(fd, -COMMIT_MESSAGE_SIZE, SEEK_END);
+
+	read(fd, &len, sizeof(int));
+	read(fd, &action, sizeof(char));
+
+	/*
+	 * If the action is not 'C' and the got length is not valid, the
+	 * transaction may be 2PC. So stop reading more.
+	 */
+	if (len != (COMMIT_MESSAGE_SIZE - sizeof(int)) &&
+		action != LOGICAL_REP_MSG_COMMIT)
+		return false;
+
+	/*
+	 * If we reach here, this file seems valid and normal transaction.
+	 * Start to read more and cache into memory to start delaying.
+	 */
+
+	/* Prepare buffer and read from file */
+	buffer = palloc0(len - sizeof(char));
+	read(fd, buffer, len - sizeof(char));
+
+	/* Append to StringInfo in order to use same read function */
+	initStringInfo(&commit_message);
+	appendBinaryStringInfo(&commit_message, buffer, len - sizeof(char));
+
+	/* Finally start to read decoded commit record */
+	logicalrep_read_commit(&commit_message, &commit_data);
+
+	/* ..and cache into the list */
+	cache_commit_data(&commit_data, xid);
+
+	pfree(buffer);
+	pfree(commit_message.data);
+
+#undef COMMIT_MESSAGE_SIZE
+
+	return true;
+}
+
+/*
+ * Read the delayed file and cache information of transaction e.g. committime.
+ *
+ * Note that apart from above, the native PREPARE/COMMIT PREPARED message is
+ * not directly written into the file. This is because gid can have arbitrary
+ * length and then we cannot estimate the offset of these records from the end
+ * of the file. Instread, the important information - prepare/commit_lsn,
+ * end_lsn, prepare/commit_time, and its transaction id are serialized.
+ * Functions for PREPARE/COMMIT PREPARED were combined because they have same
+ * attributes.
+ */
+static bool
+ReadPreparedCommonRecord(int fd)
+{
+	int len = 0;
+	char action = 0;
+
+	/*
+	 * If the transaction is 2PC, we can assume that the final record is either
+	 * or decoded prepare/commit prepared.
+	 */
+
+	/*
+	 * XXX: Modified message contains
+	 * - length
+	 * - message type
+	 * - prepare/commit_lsn
+	 * - end_lsn
+	 * - xid
+	 */
+#define PREPARE_MESSAGE_SIZE (sizeof(int) + sizeof(char) + sizeof(XLogRecPtr) + sizeof(XLogRecPtr) + sizeof(TimestampTz) + sizeof(TransactionId))
+	lseek(fd, -PREPARE_MESSAGE_SIZE, SEEK_END);
+	read(fd, &len, sizeof(int));
+	read(fd, &action, sizeof(char));
+
+	/*
+	 * Do something if the record seems to be PREPARE or COMMIT PREPARED
+	 */
+	if (len == (PREPARE_MESSAGE_SIZE - sizeof(int)) &&
+		action == LOGICAL_REP_MSG_PREPARE)
+	{
+		/* For PREPARE, do nothing */
+		return true;
+	}
+	else if (len == (PREPARE_MESSAGE_SIZE - sizeof(int)) &&
+			 LOGICAL_REP_MSG_COMMIT_PREPARED)
+	{
+		/* For COMMIT PREPARED, cache into memory and start to delay */
+
+		LogicalRepCommitData commit_data = {0};
+		TransactionId xid = InvalidTransactionId;
+
+		/* Adjust position and append to StringInfo in order to use same read function */
+		read(fd, &commit_data.commit_lsn, sizeof(XLogRecPtr));
+		read(fd, &commit_data.end_lsn, sizeof(XLogRecPtr));
+		read(fd, &commit_data.committime, sizeof(TimestampTz));
+		read(fd, &xid, sizeof(TransactionId));
+
+		cache_commit_data(&commit_data, xid);
+
+		return true;
+	}
+	else
+		return false;
+}
+
+/*
+ * Transform information from commit_prepared style to commit style.
+ */
+static void
+ConstructCommitFromCommitPrepared(LogicalRepCommitData *commit,
+						   LogicalRepCommitPreparedTxnData *prepare_data)
+{
+	commit->commit_lsn = prepare_data->commit_lsn;
+	commit->committime = prepare_data->commit_time;
+	commit->end_lsn = prepare_data->end_lsn;
+}
+
+/*
+ * Restore the delayed transaction from given files.
+ */
+static void
+RestoreDelayedTxn(char *path)
+{
+	Oid subid = InvalidOid;
+	TransactionId xid = InvalidTransactionId;
+	int fd;
+
+	/* Check filename to extract subid and xid */
+	extract_info_from_delay_file(path, &subid, &xid);
+
+	/*
+	 * If the subid is not related with the apply worker, the transaction is
+	 * out-of-scope for us...
+	 */
+	if (MyLogicalRepWorker->subid != subid)
+		return;
+
+	/* OK, the transaction must be maintained by the worker. Open file */
+	fd = BasicOpenFile(path, O_RDONLY | PG_BINARY);
+
+	/* And restore from the end of the file */
+	if (ReadCommitRecord(fd, xid))
+		goto cleanup;
+
+	if (ReadPreparedCommonRecord(fd))
+		goto cleanup;
+
+	/*
+	 * If we reach here the file seems to be corrupted. So remove once and
+	 * receive changes again.
+	 */
+	close(fd);
+	durable_unlink(path, LOG);
+	return;
+
+cleanup:
+	close(fd);
+}
+
+/*
+ * Restore all the delayed transactions to memory.
+ */
+static void
+RestoreDelayedTxns(void)
+{
+	DIR		   *delayed_dir;
+	struct dirent *delayed_de;
+
+	/* Read all the file step-by-step */
+	delayed_dir = AllocateDir(DELAYEDDIR);
+	while ((delayed_de = ReadDir(delayed_dir, DELAYEDDIR)) != NULL)
+	{
+		char		path[MAXPGPATH];
+		PGFileType	de_type;
+
+		if (strcmp(delayed_de->d_name, ".") == 0 ||
+			strcmp(delayed_de->d_name, "..") == 0)
+			continue;
+
+		/* Check the filename and status */
+		snprintf(path, sizeof(path), DELAYEDDIR "/%s", delayed_de->d_name);
+		de_type = get_dirent_type(path, delayed_de, false, DEBUG1);
+
+		if (de_type != PGFILETYPE_REG)
+			continue;
+
+		/* Found a delayed transaction. Restore it. */
+		RestoreDelayedTxn(path);
+	}
+	FreeDir(delayed_dir);
+}
+
+/*
+ * Restore delayed transactions, or initialize the directory
+ */
+static void
+InitializeDelayedTxn(void)
+{
+	struct stat st;
+	char		path[MAXPGPATH];
+
+	snprintf(path, MAXPGPATH, DELAYEDDIR);
+
+	/*
+	 * If the given directory does not exist, create one. Otherwise start to
+	 * restore.
+	 */
+	if (stat(path, &st) != 0)
+	{
+		initialize_delay_directory();
+		return;
+	}
+
+	RestoreDelayedTxns();
+}
+
+/*
+ * Write a given message to a file. This is called for every message.
+ * This returns true only when changes are written into file.
+ *
+ * The format of the serialized changes is same as the streamed one. This
+ * has a length (not including the length), action code (identifying the
+ * message type) and message contents (without the subxact TransactionId
+ * value).
+ */
+static bool
+handle_delayed_transaction(char action, StringInfo s)
+{
+	int len;
+
+	/* Return if we are not in delay */
+	if (!in_delayed_transaction)
+		return false;
+
+	Assert(delayed_fd > 0);
+	Assert(TransactionIdIsValid(delayed_xid));
+
+	len = (s->len - s->cursor) + sizeof(char);
+
+	if (write(delayed_fd, &len, sizeof(len)) != sizeof(len))
+		abort();
+	if (write(delayed_fd, &action, sizeof(action)) != sizeof(action))
+		abort();
+
+	len = (s->len - s->cursor);
+
+	if (write(delayed_fd, &s->data[s->cursor], len) != len)
+		abort();
+
+	return true;
+}
+
+/*
+ * Write a given information from PREPARE/COMMIT PREPARED to a file. This is
+ * called when we receive PREPARE or COMMIT PREPARED message. This returns true
+ * only when changes are written into file.
+ *
+ * About the needness of the function see comments atop
+ * ReadPreparedCommonRecord().
  */
-static void subxact_info_write(Oid subid, TransactionId xid);
-static void subxact_info_read(Oid subid, TransactionId xid);
-static void subxact_info_add(TransactionId xid);
-static inline void cleanup_subxact_info(void);
+static void
+handle_delayed_prepared(char action, XLogRecPtr prepare_lsn,
+						XLogRecPtr end_lsn, TimestampTz prepare_time,
+						TransactionId xid)
+{
+	int len;
+
+	Assert(delayed_fd > 0);
+
+#define MESSAGE_SIZE (sizeof(char) + sizeof(XLogRecPtr) + sizeof(XLogRecPtr) + sizeof(TimestampTz) + sizeof(TransactionId))
+	len = MESSAGE_SIZE;
+
+	/*
+	 * XXX: Modified message contains
+	 * - length
+	 * - message type
+	 * - prepare/commit_lsn
+	 * - end_lsn
+	 * - xid
+	 */
+	if (write(delayed_fd, &len, sizeof(len)) != sizeof(len))
+		abort();
+	if (write(delayed_fd, &action, sizeof(action)) != sizeof(action))
+		abort();
+	if (write(delayed_fd, &prepare_lsn, sizeof(prepare_lsn)) != sizeof(prepare_lsn))
+		abort();
+	if (write(delayed_fd, &end_lsn, sizeof(end_lsn)) != sizeof(end_lsn))
+		abort();
+	if (write(delayed_fd, &prepare_time, sizeof(prepare_time)) != sizeof(prepare_time))
+		abort();
+	if (write(delayed_fd, &xid, sizeof(xid)) != sizeof(xid))
+		abort();
+#undef MESSAGE_SIZE
+}
 
 /*
- * Serialize and deserialize changes for a toplevel transaction.
+ * Check the delayed transactions and apply if we elapsed sufficient time
  */
-static void stream_open_file(Oid subid, TransactionId xid,
-							 bool first_segment);
-static void stream_write_change(char action, StringInfo s);
-static void stream_open_and_write_change(TransactionId xid, char action, StringInfo s);
-static void stream_close_file(void);
+static void
+check_delayed_transaction(void)
+{
+	TimestampTz now;
+	ListCell   *lc;
+	int n = 0;
 
-static void send_feedback(XLogRecPtr recvpos, bool force, bool requestReply);
+	if (in_streamed_transaction)
+		return;
 
-static void DisableSubscriptionAndExit(void);
+	now = GetCurrentTimestamp();
 
-static void apply_handle_commit_internal(LogicalRepCommitData *commit_data);
-static void apply_handle_insert_internal(ApplyExecutionData *edata,
-										 ResultRelInfo *relinfo,
-										 TupleTableSlot *remoteslot);
-static void apply_handle_update_internal(ApplyExecutionData *edata,
-										 ResultRelInfo *relinfo,
-										 TupleTableSlot *remoteslot,
-										 LogicalRepTupleData *newtup,
-										 Oid localindexoid);
-static void apply_handle_delete_internal(ApplyExecutionData *edata,
-										 ResultRelInfo *relinfo,
-										 TupleTableSlot *remoteslot,
-										 Oid localindexoid);
-static bool FindReplTupleInLocalRel(EState *estate, Relation localrel,
-									LogicalRepRelation *remoterel,
-									Oid localidxoid,
-									TupleTableSlot *remoteslot,
-									TupleTableSlot **localslot);
-static void apply_handle_tuple_routing(ApplyExecutionData *edata,
-									   TupleTableSlot *remoteslot,
-									   LogicalRepTupleData *newtup,
-									   CmdType operation);
+	/* Read cache on-by-one */
+	foreach(lc, DelayedTxnList)
+	{
+		DelayedTxnListEntry *entry = (DelayedTxnListEntry *) lfirst(lc);
+		LogicalRepCommitData *commit_data = &entry->commit_data;
+		TimestampTz delayUntil;
+		long		diffms;
 
-/* Compute GID for two_phase transactions */
-static void TwoPhaseTransactionGid(Oid subid, TransactionId xid, char *gid, int szgid);
+		delayUntil = TimestampTzPlusMilliseconds(commit_data->committime,
+												 MySubscription->minapplydelay);
 
-/* Functions for skipping changes */
-static void maybe_start_skipping_changes(XLogRecPtr finish_lsn);
-static void stop_skipping_changes(void);
-static void clear_subscription_skip_lsn(XLogRecPtr finish_lsn);
+		diffms = TimestampDifferenceMilliseconds(now, delayUntil);
 
-/* Functions for apply error callback */
-static inline void set_apply_error_context_xact(TransactionId xid, XLogRecPtr lsn);
-static inline void reset_apply_error_context_info(void);
+		/*
+		 * The cache is aligned the commit ordering, so we do not have to check
+		 * latter entries if we find transactions that should not be applied.
+		 */
+		if (diffms > 0)
+			break;
 
-static TransApplyAction get_transaction_apply_action(TransactionId xid,
-													 ParallelApplyWorkerInfo **winfo);
+		elog(DEBUG1, "started to apply transaction %u", entry->xid);
+
+		apply_delayed_transaction(entry->xid, commit_data->end_lsn);
+		apply_handle_commit_internal(commit_data);
+
+		delayed_fd = -1;
+		delayed_xid = InvalidTransactionId;
+		in_delayed_transaction = false;
+		n++;
+	}
+	/* Discards applied entries */
+	DelayedTxnList = list_delete_first_n(DelayedTxnList, n);
+}
 
 /*
  * Return the name of the logical replication worker.
@@ -1019,13 +1695,28 @@ apply_handle_begin(StringInfo s)
 	logicalrep_read_begin(s, &begin_data);
 	set_apply_error_context_xact(begin_data.xid, begin_data.final_lsn);
 
-	remote_final_lsn = begin_data.final_lsn;
+	/*
+	 * Prepare to write changes into file if time-delayed replication is
+	 * requested.
+	 */
+	if (MySubscription->minapplydelay && AllTablesyncsReady())
+	{
+		in_delayed_transaction = true;
 
-	maybe_start_skipping_changes(begin_data.final_lsn);
+		create_delay_file(begin_data.xid);
 
-	in_remote_transaction = true;
+		delayed_xid = begin_data.xid;
+	}
+	else
+	{
+		remote_final_lsn = begin_data.final_lsn;
 
-	pgstat_report_activity(STATE_RUNNING, NULL);
+		maybe_start_skipping_changes(begin_data.final_lsn);
+
+		in_remote_transaction = true;
+
+		pgstat_report_activity(STATE_RUNNING, NULL);
+	}
 }
 
 /*
@@ -1037,20 +1728,40 @@ static void
 apply_handle_commit(StringInfo s)
 {
 	LogicalRepCommitData commit_data;
+	/* Save the message before it is consumed. */
+	StringInfoData original_msg = *s;
+
+	/*
+	 * If we are applying the delayed transaction, skip here.
+	 * Actual COMMIT will be done outside the apply_delayed_transaction()
+	 */
+	if (delayed_fd > 0 && !in_delayed_transaction)
+		return;
 
 	logicalrep_read_commit(s, &commit_data);
 
-	if (commit_data.commit_lsn != remote_final_lsn)
-		ereport(ERROR,
-				(errcode(ERRCODE_PROTOCOL_VIOLATION),
-				 errmsg_internal("incorrect commit LSN %X/%X in commit message (expected %X/%X)",
-								 LSN_FORMAT_ARGS(commit_data.commit_lsn),
-								 LSN_FORMAT_ARGS(remote_final_lsn))));
+	/* If we are applying, skip here. */
+
+	if (in_delayed_transaction)
+	{
+		/* Write a commit message into file and flush all of messages */
+		handle_delayed_transaction(LOGICAL_REP_MSG_COMMIT, &original_msg);
+		flush_delayed_changes(&commit_data);
+	}
+	else
+	{
+		if (commit_data.commit_lsn != remote_final_lsn)
+			ereport(ERROR,
+					(errcode(ERRCODE_PROTOCOL_VIOLATION),
+					errmsg_internal("incorrect commit LSN %X/%X in commit message (expected %X/%X)",
+									LSN_FORMAT_ARGS(commit_data.commit_lsn),
+									LSN_FORMAT_ARGS(remote_final_lsn))));
 
-	apply_handle_commit_internal(&commit_data);
+		apply_handle_commit_internal(&commit_data);
 
-	/* Process any tables that are being synchronized in parallel. */
-	process_syncing_tables(commit_data.end_lsn);
+		/* Process any tables that are being synchronized in parallel. */
+		process_syncing_tables(commit_data.end_lsn);
+	}
 
 	pgstat_report_activity(STATE_IDLE, NULL);
 	reset_apply_error_context_info();
@@ -1076,13 +1787,28 @@ apply_handle_begin_prepare(StringInfo s)
 	logicalrep_read_begin_prepare(s, &begin_data);
 	set_apply_error_context_xact(begin_data.xid, begin_data.prepare_lsn);
 
-	remote_final_lsn = begin_data.prepare_lsn;
+	/*
+	 * Prepare to write changes into file if time-delayed replication is
+	 * requested.
+	 */
+	if (MySubscription->minapplydelay && AllTablesyncsReady())
+	{
+		in_delayed_transaction = true;
+
+		create_delay_file(begin_data.xid);
+
+		delayed_xid = begin_data.xid;
+	}
+	else
+	{
+		remote_final_lsn = begin_data.prepare_lsn;
 
-	maybe_start_skipping_changes(begin_data.prepare_lsn);
+		maybe_start_skipping_changes(begin_data.prepare_lsn);
 
-	in_remote_transaction = true;
+		in_remote_transaction = true;
 
-	pgstat_report_activity(STATE_RUNNING, NULL);
+		pgstat_report_activity(STATE_RUNNING, NULL);
+	}
 }
 
 /*
